-- Mouse stuff to replicate the cursor on screen when it's normally hidden.	
local ZkrattMouseLookMode = false;
local ZkrattTurnOrActionMode = false;
local ZkrattCameraOrSelectOrMoveMode = false;
local ZkrattMoveAndSteerMode = false;
local ZkrattCursorX, ZkrattCursorY;
--Hooking secure functions on behest of the mouse.
function Zkratt_InMouseLookingMode() 
ZkrattMouseLookMode=true; Zkratt_InLookingMode(); end
hooksecurefunc("MouselookStart",Zkratt_InMouseLookingMode)
	
function Zkratt_NoMouseLookingMode() 
ZkrattMouseLookMode=false; Zkratt_InLookingMode(); end
hooksecurefunc("MouselookStop",Zkratt_NoMouseLookingMode)
	
function Zkratt_InTurnOrActionMode() 
ZkrattTurnOrActionMode=true; Zkratt_InLookingMode(); end
hooksecurefunc("TurnOrActionStart",Zkratt_InTurnOrActionMode)
	
function Zkratt_NoTurnOrActionMode() 
ZkrattTurnOrActionMode=false; Zkratt_InLookingMode(); end
hooksecurefunc("TurnOrActionStop",Zkratt_NoTurnOrActionMode)
	
function Zkratt_InCameraOrSelectOrMoveMode() 
ZkrattCameraOrSelectOrMoveMode=true; Zkratt_InLookingMode(); end
hooksecurefunc("CameraOrSelectOrMoveStart",Zkratt_InCameraOrSelectOrMoveMode)
	
function Zkratt_NoCameraOrSelectOrMoveMode() 
ZkrattCameraOrSelectOrMoveMode=false; Zkratt_InLookingMode(); end
hooksecurefunc("CameraOrSelectOrMoveStop",Zkratt_NoCameraOrSelectOrMoveMode)

function Zkratt_InMoveAndSteer() 
ZkrattMoveAndSteerMode=true; Zkratt_InLookingMode(); end
hooksecurefunc("MoveAndSteerStart",Zkratt_InMoveAndSteer)
	
function Zkratt_NoMoveAndSteer() 
ZkrattMoveAndSteerMode=false; Zkratt_InLookingMode(); end
hooksecurefunc("MoveAndSteerStop",Zkratt_NoMoveAndSteer)

function Zkratt_InLookingMode()
-- Keeping track of the track of the cursor even when it is hidden.
	Zkratt_ReplicatedCursorDraw();
end

-- Replicate the cursor when rightclicking
Zkratt_CursorReplica = CreateFrame("Frame", nil, UIParent);
Zkratt_CursorReplica:SetFrameStrata("TOOLTIP");
Zkratt_ReplicatedCursor = Zkratt_CursorReplica:CreateTexture();
Zkratt_ReplicatedCursor:SetTexture("Interface\\Cursor\\UnablePoint");

-- DRAW THE MOUSE TRACKER
	-- Draws the mouse cursor being tracked.
	function Zkratt_ReplicatedCursorDraw()
	
		--[[ToDo:
			The following 'if' statement... is it even needed? if so, can it be improved?]]--
		if ZkrattMouseLookMode or ZkrattTurnOrActionMode or ZkrattCameraOrSelectOrMoveMode or ZkrattMoveAndSteerMode then
		
			local CursorX, CursorY = GetCursorPosition();
			local UIScale = UIParent:GetEffectiveScale();
			local Size = 23/UIScale;
			--ZkrattDebug("UIScale",UIScale);
			Zkratt_ReplicatedCursor:SetTexture("Interface\\Cursor\\UnablePoint"); ---> shouldn't exist here
			Zkratt_ReplicatedCursor:SetAlpha(0.5);
			Zkratt_ReplicatedCursor:SetHeight(Size);
			Zkratt_ReplicatedCursor:SetWidth(Size);
			Zkratt_ReplicatedCursor:SetPoint("TOPLEFT",UIParent,"BOTTOMLEFT",CursorX/UIScale,CursorY/UIScale);
			Zkratt_ReplicatedCursor:Show();
		else
			Zkratt_ReplicatedCursor:Hide();
		end
	end




